<template>
  <BasicModal v-bind="$attrs" @register="registerModal" :title="title" @ok="handleSubmit" width="50%">
    <BasicForm @register="registerForm"> </BasicForm>
  </BasicModal>
</template>

<script lang="ts" setup>
import { ref } from 'vue';
import { FormSchema } from '/@/components/Table';
import { BasicModal, useModalInner } from '/@/components/Modal';
import { BasicForm, useForm } from '/@/components/Form/index';
import { sendBack } from '/@/api/common/api';
// Emits声明
import { useMessage } from '/@/hooks/web/useMessage';

const { createMessage } = useMessage();
const emit = defineEmits(['register', 'success']);

const AdviceFormSchema: FormSchema[] = [
  { label: '污染地块ID', field: 'wrdkid', component: 'Input', show: false },
  { label: '所处阶段编码', field: 'scjdbm', component: 'Input', show: false },
  { label: 'pgtype', field: 'pgtype', component: 'Input', show: false },
  { label: '填报阶段编码', field: 'jdnzt', component: 'Input', show: false },
  {
    label: '下一节点',
    field: 'nodeType',
    component: 'RadioGroup',
    required: true,
    defaultValue: 2,
    componentProps: {
      options: [{ label: '退回', value: 2 }],
    },
  },
  {
    label: '办理意见',
    required: true,
    field: 'clyj',
    component: 'InputTextArea',
  },
  {
    label: '附件',
    field: 'clyjfj',
    required: true,
    component: 'JUpload',
    componentProps: {
      showUploadList: false,
      accept: '.pdf,.zip',
      beforeUpload: (file) => {
        let isshow = false;
        if (file.type == 'application/pdf' || file.type == 'application/x-zip-compressed') {
          isshow = true;
        } else {
          createMessage.error('只能上传.pdf/.zip格式的文件');
          isshow = false;
        }
        return isshow;
      },
    },
  },
];
//表单配置
const [registerForm, { resetFields, setFieldsValue, validate }] = useForm({
  labelWidth: 220,
  schemas: AdviceFormSchema,
  showActionButtonGroup: false,
});
//表单赋值
const [registerModal, { setModalProps, closeModal }] = useModalInner(async (data) => {
  //重置表单
  await resetFields();
  setModalProps({ confirmLoading: false, showCancelBtn: data?.showFooter, showOkBtn: data?.showFooter });
  //表单赋值
  await setFieldsValue({
    ...data.record,
  });
});
//设置标题
const title = ref('退回无需修改');
//表单提交事件
async function handleSubmit() {
  try {
    let values = await validate();
    setModalProps({ confirmLoading: true });
    //提交表单
    await sendBack(values);
    //关闭弹窗
    closeModal();
    emit('success');
  } finally {
    setModalProps({ confirmLoading: false });
  }
}
</script>

<style lang="less" scoped></style>
